package model

import "shylinux.com/x/mysql-story/src/db"

const (
	UID             = "uid"
	NAME            = "name"
	TYPE            = "type"
	ROLE            = "role"
	TITLE           = "title"
	CONTENT         = "content"
	USER_UID        = "user_uid"
	USER_REPOS_ROLE = "user_repos_role"
	REPOS_UID       = "repos_uid"
	REPOS_NAME      = "repos_name"
	REPOS_TYPE      = "repos_type"
	RELEASE_UID     = "release_uid"
	COMPANY_UID     = "company_uid"
	CITY_UID        = "city_uid"
)

type UserRepos struct {
	db.ModelWithUID
	UserUID  string `gorm:"type:char(32);index"`
	ReposUID string `gorm:"type:char(32);index"`
	Role     uint8  `gorm:"default:0"`
}
type Repos struct {
	db.ModelWithUID
	CompanyUID string `gorm:"type:char(32);index"`
	Name       string `gorm:"type:varchar(64)"`
	Type       uint8  `gorm:"default:0"`
}
type Release struct {
	db.ModelWithUID
	ReposUID string `gorm:"type:char(32);index"`
	UserUID  string `gorm:"type:char(32);index"`
	Title    string `gorm:"type:varchar(64)"`
	Content  string
}

func init() { db.CmdModels("", &UserRepos{}, &Repos{}, &Release{}) }
