package development

import (
	"shylinux.com/x/ice"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/enterprise/src/development/model"
)

type release struct {
	Table
	repos     repos
	userRepos userRepos
	create    string `name:"create title* content*" role:"leader"`
}

func (s release) Create(m *ice.Message, arg ...string) {
	s.Table.Create(m, kit.Simple(arg, m.OptionSimple(model.USER_UID, model.REPOS_UID))...)
	s.recordEventWithName(m, "")
}
func (s release) List(m *ice.Message, arg ...string) {
	s.TablesWithRole(m, arg, s.userRepos, s.repos, s, model.TITLE, model.CONTENT).Display("")
}

func init() { ice.TeamCtxCmd(release{}) }
