package development

import (
	"shylinux.com/x/ice"

	"shylinux.com/x/enterprise/src/development/model"
)

type userRepos struct {
	Table
	repos repos
}

func (s userRepos) User(m *ice.Message, arg ...string) {
	s.FieldsWithCreatedAT(m, s, model.USER_UID, model.ROLE)
	if len(arg) == 1 {
		s.Select(m, model.REPOS_UID, arg[0])
	} else if len(arg) == 2 {
		s.SelectDetail(m, model.REPOS_UID, arg[0], model.UID, arg[1])
	} else {
		return
	}
	m.RenameAppend(model.ROLE, model.USER_REPOS_ROLE)
	s.SelectJoinUser(m)
}
func (s userRepos) List(m *ice.Message, arg ...string) {
	s.Tables(m, s.repos).FieldsWithCreatedAT(m, s,
		model.REPOS_NAME, model.REPOS_TYPE, model.USER_REPOS_ROLE,
		model.COMPANY_UID, model.REPOS_UID,
	)
	if len(arg) == 1 {
		s.Select(m, model.USER_UID, arg[0])
	} else if len(arg) == 2 {
		s.SelectDetail(m, model.USER_UID, arg[0], model.REPOS_UID, arg[1])
	} else {
		return
	}
	s.SelectJoinCompany(m)
	s.SelectJoinCity(m)
}

func init() { ice.TeamCtxCmd(userRepos{}) }

type UserReposRole int

const (
	UserReposVisitor UserReposRole = iota
	UserReposCreator
	UserReposLeader
	UserReposWorker
	UserReposServer
)

var UserReposRoleList = map[UserReposRole]string{
	UserReposVisitor: "visitor",
	UserReposCreator: "creator",
	UserReposLeader:  "leader",
	UserReposWorker:  "worker",
	UserReposServer:  "server",
}

func (s UserReposRole) String() string { return UserReposRoleList[s] }
