package gongyinglian

import (
	"shylinux.com/x/ice"

	"shylinux.com/x/enterprise/src/gongyinglian/model"
)

type express struct {
	Table
	order Order
}

func (s express) List(m *ice.Message, arg ...string) {
	if !s.checkListRole(m, arg...) {
		return
	}
	s.Tables(m, s.order).FieldsWithCreatedAT(m, s,
		s.AS(model.TO_USER_UID, model.USER_UID), model.EXPRESS_STATUS,
		model.COMPANY_UID, model.OPEN_ID, model.ORDER_UID,
	)
	if len(arg) == 1 {
		s.Select(m, model.FROM_STORE_UID, arg[0]).Action()
	} else if len(arg) == 2 {
		s.SelectDetail(m, model.FROM_STORE_UID, arg[0], s.Key(s, model.UID), arg[1])
	} else {
		return
	}
	s.SelectJoinCompany(m)
	s.SelectJoinUser(m)
}

func init() { ice.TeamCtxCmd(express{}) }

type ExpressStatus int

const (
	ExpressUnknown ExpressStatus = iota
	ExpressCreate
	ExpressSend
	ExpressRecv
	ExpressConfirm
)

var ExpressStatusList = map[ExpressStatus]string{
	ExpressUnknown: "unknown",
	ExpressCreate:  "create",
	ExpressSend:    "send",
	ExpressRecv:    "recv",
	ExpressConfirm: "confirm",
}

func (s ExpressStatus) String() string { return ExpressStatusList[s] }
