package gongyinglian

import (
	"shylinux.com/x/ice"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/enterprise/src/gongyinglian/model"
)

type loan struct {
	TableView
	fields string `data:"loan_type,amount,name,info"`
	create string `name:"create loan_type* amount name info" role:"boss"`
	modify string `name:"modify name info amount" role:"boss"`
}

func (s loan) Create(m *ice.Message, arg ...string) {
	arg = kit.TransArgKeys(arg, model.LOAN_TYPE, model.TYPE)
	s.TableView.Create(m, kit.Simple(arg, model.TO_USER_UID, m.Option(model.USER_UID))...)
}
func (s loan) List(m *ice.Message, arg ...string) {
	if s.checkListRole(m, arg...) {
		s.TableView.List(m, arg...)
	}
}

func init() { ice.TeamCtxCmd(loan{}) }

type LoanType int

const (
	LoanTerm LoanType = iota
)

var LoanTypeList = map[LoanType]string{
	LoanTerm: "term",
}

func (s LoanType) String() string { return LoanTypeList[s] }
