package gongyinglian

import (
	"shylinux.com/x/ice"

	"shylinux.com/x/enterprise/src/gongyinglian/model"
)

type refund struct {
	Table
	order Order
}

func (s refund) List(m *ice.Message, arg ...string) {
	if !s.checkListRole(m, arg...) {
		return
	}
	s.Tables(m, s.order).FieldsWithCreatedAT(m, s,
		s.AS(model.TO_USER_UID, model.USER_UID), model.REFUND_STATUS,
		model.COMPANY_UID, model.OPEN_ID, model.ORDER_UID,
		s.Key(s.order, model.AMOUNT), model.TOTAL,
	)
	if len(arg) == 1 {
		s.Select(m, model.FROM_STORE_UID, arg[0]).Action()
	} else if len(arg) == 2 {
		s.SelectDetail(m, model.FROM_STORE_UID, arg[0], s.Key(s, model.UID), arg[1])
	} else {
		return
	}
	s.SelectJoinCompany(m)
	s.SelectJoinUser(m)
}

func init() { ice.TeamCtxCmd(refund{}) }

type RefundStatus int

const (
	RefundUnknown RefundStatus = iota
	RefundCreate
	RefundFailure
	RefundSuccess
	RefundConfirm
)

var RefundStatusList = map[RefundStatus]string{
	RefundUnknown: "unknown",
	RefundCreate:  "create",
	RefundFailure: "failure",
	RefundSuccess: "success",
	RefundConfirm: "confirm",
}

func (s RefundStatus) String() string { return RefundStatusList[s] }
