package gongyinglian

import (
	"shylinux.com/x/ice"

	"shylinux.com/x/enterprise/src/gongyinglian/model"
)

type Return struct {
	Table
	order Order
}

func (s Return) List(m *ice.Message, arg ...string) {
	if !s.checkListRole(m, arg...) {
		return
	}
	s.Tables(m, s.order).FieldsWithCreatedAT(m, s,
		s.AS(model.TO_USER_UID, model.USER_UID), model.RETURN_STATUS,
		model.COMPANY_UID, model.OPEN_ID, model.ORDER_UID,
	)
	if len(arg) == 1 {
		s.Select(m, model.FROM_STORE_UID, arg[0]).Action()
	} else if len(arg) == 2 {
		s.SelectDetail(m, model.FROM_STORE_UID, arg[0], s.Key(s, model.UID), arg[1])
	} else {
		return
	}
	s.SelectJoinCompany(m)
	s.SelectJoinUser(m)
}

func init() { ice.TeamCtxCmd(Return{}) }

type ReturnStatus int

const (
	ReturnUnknown ReturnStatus = iota
	ReturnCreate
	ReturnSend
	ReturnRecv
	ReturnConfirm
)

var ReturnStatusList = map[ReturnStatus]string{
	ReturnUnknown: "unknown",
	ReturnCreate:  "create",
	ReturnSend:    "send",
	ReturnRecv:    "recv",
	ReturnConfirm: "confirm",
}

func (s ReturnStatus) String() string { return ReturnStatusList[s] }
