package gongyinglian

import (
	"shylinux.com/x/ice"

	"shylinux.com/x/enterprise/src/gongyinglian/model"
)

type userStore struct {
	Table
	store store
}

func (s userStore) User(m *ice.Message, arg ...string) {
	s.FieldsWithCreatedAT(m, s, model.USER_UID, model.ROLE)
	if len(arg) == 1 {
		s.Select(m, model.STORE_UID, arg[0])
	} else if len(arg) == 2 {
		s.SelectDetail(m, model.STORE_UID, arg[0], model.UID, arg[1])
	} else {
		return
	}
	m.RenameAppend(model.ROLE, model.USER_STORE_ROLE)
	s.SelectJoinUser(m)
}
func (s userStore) List(m *ice.Message, arg ...string) {
	s.Tables(m, s.store).FieldsWithCreatedAT(m, s,
		model.STORE_NAME, model.STORE_TYPE, model.USER_STORE_ROLE,
		model.COMPANY_UID, model.STORE_UID,
		model.INIT,
	)
	if len(arg) == 1 {
		s.Select(m, model.USER_UID, arg[0])
	} else if len(arg) == 2 {
		s.SelectDetail(m, model.USER_UID, arg[0], s.Key(s, model.STORE_UID), arg[1])
	} else {
		return
	}
	s.SelectJoinCompany(m)
	s.SelectJoinCity(m)
}

func init() { ice.TeamCtxCmd(userStore{}) }

type UserStoreRole int

const (
	UserStoreVisitor UserStoreRole = iota
	UserStoreCreator
	UserStoreBoss
	UserStoreWorker
	UserStoreVendor
	UserStoreCustom
)

var UserStoreRoleList = map[UserStoreRole]string{
	UserStoreCreator: "creator",
	UserStoreVisitor: "visitor",
	UserStoreBoss:    "boss",
	UserStoreWorker:  "worker",
	UserStoreVendor:  "vendor",
	UserStoreCustom:  "custom",
}

func (s UserStoreRole) String() string { return UserStoreRoleList[s] }
