package operation

import (
	"shylinux.com/x/ice"

	"shylinux.com/x/enterprise/src/operation/model"
)

type userCloud struct {
	Table
	cloud cloud
}

func (s userCloud) User(m *ice.Message, arg ...string) {
	s.FieldsWithCreatedAT(m, s, model.USER_UID, model.ROLE)
	if len(arg) == 1 {
		s.Select(m, model.CLOUD_UID, arg[0])
	} else if len(arg) == 2 {
		s.SelectDetail(m, model.CLOUD_UID, arg[0], model.UID, arg[1])
	} else {
		return
	}
	m.RenameAppend(model.ROLE, model.USER_CLOUD_ROLE)
	s.SelectJoinUser(m)
}
func (s userCloud) List(m *ice.Message, arg ...string) {
	s.Tables(m, s.cloud).FieldsWithCreatedAT(m, s,
		model.CLOUD_NAME, model.CLOUD_TYPE, model.USER_CLOUD_ROLE,
		model.COMPANY_UID, model.CLOUD_UID,
	)
	if len(arg) == 1 {
		s.Select(m, model.USER_UID, arg[0])
	} else if len(arg) == 2 {
		s.SelectDetail(m, model.USER_UID, arg[0], s.Key(s, model.CLOUD_UID), arg[1])
	} else {
		return
	}
	s.SelectJoinCompany(m)
	s.SelectJoinCity(m)
}

func init() { ice.TeamCtxCmd(userCloud{}) }

type UserCloudRole int

const (
	UserCloudVisitor UserCloudRole = iota
	UserCloudCreator
	UserCloudLeader
	UserCloudWorker
	UserCloudServer
)

var UserCloudRoleList = map[UserCloudRole]string{
	UserCloudVisitor: "visitor",
	UserCloudCreator: "creator",
	UserCloudLeader:  "leader",
	UserCloudWorker:  "worker",
	UserCloudServer:  "server",
}

func (s UserCloudRole) String() string { return UserCloudRoleList[s] }
