package shichangyingxiao

import (
	"shylinux.com/x/ice"

	"shylinux.com/x/enterprise/src/shichangyingxiao/model"
)

type userChannel struct {
	Table
	channel  channel
}

func (s userChannel) User(m *ice.Message, arg ...string) {
	s.FieldsWithCreatedAT(m, s, model.USER_UID, model.ROLE)
	if len(arg) == 1 {
		s.Select(m, model.CHANNEL_UID, arg[0])
	} else if len(arg) == 2 {
		s.SelectDetail(m, model.CHANNEL_UID, arg[0], model.UID, arg[1])
	} else {
		return
	}
	m.RenameAppend(model.ROLE, model.USER_CHANNEL_ROLE)
	s.SelectJoinUser(m)
}
func (s userChannel) List(m *ice.Message, arg ...string) {
	s.Tables(m, s.channel).FieldsWithCreatedAT(m, s,
		model.CHANNEL_NAME, model.CHANNEL_TYPE, model.USER_CHANNEL_ROLE,
		model.COMPANY_UID, model.CHANNEL_UID,
	)
	if len(arg) == 1 {
		s.Select(m, model.USER_UID, arg[0])
	} else if len(arg) == 2 {
		s.SelectDetail(m, model.USER_UID, arg[0], s.Key(s, model.CHANNEL_UID), arg[1])
	} else {
		return
	}
	s.SelectJoinCompany(m)
	s.SelectJoinCity(m)
}

func init() { ice.TeamCtxCmd(userChannel{}) }

type UserChannelRole int

const (
	UserChannelVisitor UserChannelRole = iota
	UserChannelCreator
	UserChannelLeader
	UserChannelWorker
	UserChannelServer
)

var UserChannelRoleList = map[UserChannelRole]string{
	UserChannelVisitor: "visitor",
	UserChannelCreator: "creator",
	UserChannelLeader: "leader",
	UserChannelWorker: "worker",
	UserChannelServer: "server",
}

func (s UserChannelRole) String() string { return UserChannelRoleList[s] }