package model

import "shylinux.com/x/mysql-story/src/db"

const (
	UID             = "uid"
	NAME            = "name"
	TYPE            = "type"
	ROLE            = "role"
	TITLE           = "title"
	CONTENT         = "content"
	USER_UID        = "user_uid"
	USER_INVESTOR_ROLE = "user_investor_role"
	INVESTOR_UID       = "investor_uid"
	INVESTOR_NAME      = "investor_name"
	INVESTOR_TYPE      = "investor_type"
	INVESTMENT_UID       = "_uid"
	COMPANY_UID        = "company_uid"
	CITY_UID        = "city_uid"
)

type UserInvestor struct {
	db.ModelWithUID
	UserUID  string `gorm:"type:char(32);index"`
	InvestorUID string `gorm:"type:char(32);index"`
	Role     uint8 `gorm:"default:0"`
}
type Investor struct {
	db.ModelWithUID
	CompanyUID string `gorm:"type:char(32);index"`
	Name       string `gorm:"type:varchar(64)"`
	Type       uint8  `gorm:"default:0"`
}
type Investment struct {
	db.ModelWithUID
	InvestorUID string `gorm:"type:char(32);index"`
	UserUID  string `gorm:"type:char(32);index"`
	Title    string `gorm:"type:varchar(64)"`
	Content  string
}


func init() { db.CmdModels("", &UserInvestor{}, &Investor{}, &Investment{}) }